--xItemComms #3
--Renderer - Vaccum Succer
--written by minenice

--base price: 15$
--extra: debug cycle +5$

freeslot(
	"MT_XITEM_RENSUCCHITBOX",
	"S_XITEM_RENSUCCHITBOX",
	
	"S_XITEM_RENSUCCPARTICLE",
	
	"SPR_XIRS",
	
	"sfx_rnsucc",
	"sfx_rnsend"
)

--things the client can change to adjust their crap
local vacuumActiveTime = 10*TICRATE
local vacuumRadius = 256*FRACUNIT
local vacuumOffset = 64*FRACUNIT
local succPower = 36*FRACUNIT
local usefor = "profrenderer" --replace this with the character's realname, in all lowercase

mobjinfo[MT_XITEM_RENSUCCHITBOX] = {
	doomednum = -1,
    spawnstate = S_XITEM_RENSUCCHITBOX,
    spawnhealth = 9000,
    radius = vacuumRadius,
    height = 64*FRACUNIT,
    flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

states[S_XITEM_RENSUCCHITBOX] = {
	sprite = SPR_NULL,
	frame = A,
	tics = -1,
	nextstate = S_NULL,
}

states[S_XITEM_RENSUCCPARTICLE] = {
	sprite = SPR_DUST,
	frame = TR_TRANS40|A,
	tics = 1,
	action = A_HomingChase,
	var1 = 20*FRACUNIT,
	var2 = 0,
	nextstate = S_XITEM_RENSUCCPARTICLE,
}

--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_driftcharge = k_driftcharge

--thank you callmore
local function shouldHurt(p)
	return not (p.powers[pw_flashing] > 0 or p.kartstuff[k_squishedtimer] > 0 or p.kartstuff[k_spinouttimer] > 0
		or p.kartstuff[k_invincibilitytimer] > 0 or p.kartstuff[k_growshrinktimer] > 0 or p.kartstuff[k_hyudorotimer] > 0 
		or (G_BattleGametype() and ((p.kartstuff[k_bumper] <= 0 and p.kartstuff[k_comebacktimer]) or p.kartstuff[k_comebackmode] == 1)))
end

local function AT_flerp(num, denum, minimum, maximum)
	local p = FixedDiv(num, denum)
	local a = FixedMul((maximum - minimum), p)
	local v = minimum + a
	return v
end

--thanks call
local function generateHFForPlayer(p)
    if p and p.valid and p.mo and p.mo.valid then
        return {{p.name, p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
    else
        return {{}, {}}
    end
end

local function useVaccum(p, cmd)
	local mo = p.mo
	if not mo.vaccumActiveTics then
		mo.vaccumActiveTics = vacuumActiveTime
		local hitbox = P_SpawnMobj(mo.x, mo.y, mo.z, MT_XITEM_RENSUCCHITBOX)
		p.vaccumHitbox = hitbox
		p.usedVaccum = true
		hitbox.source = mo
		p.kartstuff[k_driftboost] = vacuumActiveTime		-- Gives the user miniturbos upon using vacuum; meant to speed up the user when they otherwise can't use items
		S_StartSound(mo, sfx_rnsucc)
		--p.kartstuff[k_itemheld] = true
	end
end

local function vaccumHud(v, p, c)
	local mo = p.mo
	if p.usedVaccum then
		xItemLib.func.hudDrawItem(v, p, c, xItemLib.xItemNamespaces["XITEM_RENSUCC"], 2)
		p.xItemData.xItem_timerBar = mo.vaccumActiveTics or 0
		p.xItemData.xItem_maxTimerBar = vacuumActiveTime
	else
		xItemLib.func.hudDrawItem(v, p, c, xItemLib.xItemNamespaces["XITEM_RENSUCC"])
	end	
	p.xItemData.xItem_timerBar = mo.vaccumActiveTics or 0
	p.xItemData.xItem_maxTimerBar = vacuumActiveTime
end

local function vaccumOdds(newodds, pos, mashed, spbrush, p)
	if p.mo.skin == usefor then 
		return newodds
	else
		return 0
	end
end

local function vaccumShow(p)
	return p.mo.skin == usefor
end

local function vacuumDropped(mo, i, amt)
	mo.threshold = KITEM_GROW
	return SPR_ITEM, 11
end

if xItemLib then
	xItemLib.func.addItem{"XITEM_RENSUCC", 
		"Vacuum", 
		"K_ITRSUC", 
		"K_ISRSUC", 
		0, 
		{0, 0, 1, 2, 2, 5, 12, 6, 2, 0}, 
		{4, 0}, 
		nil, 
		useVaccum, 
		vaccumHud, 
		vaccumOdds, 
		nil, 
		{0, {SPR_XIRS, 0}},
		vaccumShow,
		nil,
		vacuumDropped
	}
end

local function handleVaccum(p)
	local mo = p.mo
	if p.kartstuff[k_itemtype] == xItemLib.xItemNamespaces["XITEM_RENSUCC"] then
		if mo.skin ~= usefor then
			if p.usedVaccum then
				if p.vaccumHitbox and p.vaccumHitbox.valid then P_RemoveMobj(p.vaccumHitbox) end
				mo.vaccumActiveTics = 0
			p.usedVaccum = false
			end
			p.kartstuff[k_itemtype] = KITEM_GROW
		end
		if p.usedVaccum and not mo.vaccumActiveTics then
			if p.vaccumHitbox and p.vaccumHitbox.valid then P_RemoveMobj(p.vaccumHitbox) end
			p.kartstuff[k_itemamount] = $-1
			if p.kartstuff[k_itemamount] == 0 then
				p.kartstuff[k_itemtype] = 0
			end
			p.usedVaccum = false
			if p.health then
				S_StartSound(mo, sfx_rnsend)
			end
			--p.kartstuff[k_itemheld] = false
		elseif p.usedVaccum then
			mo.vaccumActiveTics = $-1
		end
	else
		if p.usedVaccum then
			if p.vaccumHitbox then P_RemoveMobj(p.vaccumHitbox) end
			mo.vaccumActiveTics = 0
			p.usedVaccum = false
		end
	end
end

addHook("MobjFuse", function(mo)
	if mo.state == S_XITEM_RENSUCCPARTICLE then
		P_RemoveMobj(mo)
	end
end, MT_THOK)

addHook("ThinkFrame", do
	for p in players.iterate do
		local mo = p.mo
		local kartstuff = p.kartstuff
		local cmd = p.cmd
		if leveltime == 0 then 
			p.usedVaccum = false
			mo.vaccumActiveTics = 0
		end
		handleVaccum(p)
	end
end)

local function startSucc(mo, col)
	--print("start succ")
	if col and col.source and mo then
		if mo.z + mo.height < col.z then return end
		if mo.z > col.z + col.height then return end
		--func body here
		if mo == col.source then return end
		if (mo.player and not shouldHurt(mo.player)) then return end
		local dist = R_PointToDist2(mo.x, mo.y, col.x, col.y)
		if dist <= col.radius then
			mo.succTarget = col.source
			mo.succSafeTime = TICRATE*5
		end
		--mo.momx = 0
		--mo.momy = 0
		--mo.momz = 0
	end
end

local function getSucced(mo)
	
	if mo.succTarget then
		if mo.succTarget ~= mo then
			local succt = mo.succTarget
			local succMinDist = FixedMul(succt.radius + mo.radius + 64*FRACUNIT, succt.scale)
			local succMaxDist = FixedMul(succt.radius + mo.radius + vacuumOffset + vacuumRadius, succt.scale)
			--A_HomingChase code
			local movangle = R_PointToAngle2(mo.x, mo.y, succt.x, succt.y)
			local dist = R_PointToDist2(0, mo.x, R_PointToDist2(mo.y, mo.z, succt.y, succt.z), succt.x)
			if dist <= succMinDist then
				if mo.type == MT_PLAYER and mo.player then
					mo.player.kartstuff[k_squishedtimer] = TICRATE
					mo.player.powers[pw_flashing] = 8
					K_PlayHitEmSound(succt)
					
					-- Long overdue Hitfeed compat (and also horribly broken) by Professor Renderer
					if (hitfeed) then
						local source = generateHFForPlayer(mo.succTarget)
						local victim = generateHFForPlayer(mo.player)
						HF_SendHitMessage(source, victim, "H_ISRSUC")
					end
				else
					P_KillMobj(mo, succt, succt.source)
				end
				mo.succTarget = nil
				mo.succSafeTime = -TICRATE/2
			end
			if dist > succMaxDist then
				mo.succTarget = nil
				mo.succSafeTime = -TICRATE/2
			end
			if mo.succSafeTime > 0 then
				mo.succSafeTime = $-1
			else
				if mo.succSafeTime < 0 then mo.succSafeTime = $+1 end
				mo.succTarget = nil
			end
			local speedmul = FixedMul(succPower, succt.scale)
			mo.momx = FixedMul(FixedDiv(succt.x - mo.x, dist), speedmul)
			mo.momy = FixedMul(FixedDiv(succt.y - mo.y, dist), speedmul)
			mo.momz = FixedMul(FixedDiv(succt.z - mo.z, dist), speedmul)
		end
	else
		for p in players.iterate do
			if p.vaccumHitbox and p.vaccumHitbox.valid then
				if mo == p.mo then continue end
				local succbox = p.vaccumHitbox
				local succMaxDist = FixedMul(p.mo.radius + mo.radius + vacuumOffset + vacuumRadius, p.mo.scale)
				local succMinDist = FixedMul(p.mo.radius + mo.radius, p.mo.scale)
				local dist = R_PointToDist2(mo.x, mo.y, succbox.x, succbox.y)
				if dist <= succMaxDist and dist > succMinDist then
					--print("start succ")
					startSucc(mo, succbox)
				end
			end
		end
	end
end

addHook("MobjThinker", getSucced, MT_BANANA)
addHook("MobjThinker", getSucced, MT_ORBINAUT)
addHook("MobjThinker", getSucced, MT_BALLHOG)
addHook("MobjThinker", getSucced, MT_JAWZ)
addHook("MobjThinker", getSucced, MT_JAWZ_DUD)
addHook("MobjThinker", getSucced, MT_PLAYER)

local function ignoresuccedcol(mo, other)
	if mo.player and mo.vaccumActiveTics then 
		if other.type == MT_BANANA or
			other.type == MT_ORBINAUT or
			other.type == MT_JAWZ_DUD or
			other.type == MT_PLAYER
			and other.succTarget == mo then
			if other.type == MT_PLAYER and other.player then
				other.player.kartstuff[k_squishedtimer] = TICRATE
				other.player.powers[pw_flashing] = 8
				K_PlayHitEmSound(mo)
			else
				P_KillMobj(other, mo, mo.source)
			end
			other.succTarget = nil
			return false
		end
	end
end
addHook("MobjMoveCollide", ignoresuccedcol, MT_PLAYER)

addHook("MobjThinker", function(mo)
	if mo.source and mo.source.health then
		P_MoveOrigin(mo, mo.source.x + P_ReturnThrustX(mo, mo.source.angle, FixedMul(mo.source.radius + mo.radius + vacuumOffset, mo.source.scale)), mo.source.y + P_ReturnThrustY(mo, mo.source.angle, FixedMul(mo.source.radius + mo.radius + vacuumOffset, mo.source.scale)), mo.source.z)
		local particle = P_SpawnMobj(mo.x + mo.scale*P_RandomRange(-128, 128), mo.y + mo.scale*P_RandomRange(-128, 128), mo.z + FRACUNIT*P_RandomRange(-2, 12), MT_THOK)
		particle.state = S_XITEM_RENSUCCPARTICLE
		particle.target = mo.source
		particle.fuse = TICRATE/3
	else
		P_RemoveMobj(mo)
	end
end, MT_XITEM_RENSUCCHITBOX)